//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "Graph.h"

//---------------------------------------------------------------------------

#define GRAPH_AREA_LEFT			80	//
#define GRAPH_AREA_BOTTOM		60	//

#define GRAPH_AREA_RIGHT		80	//
#define GRAPH_AREA_TOP			25	//

#define GRAPH_AREA_WIDTH		(GraphPaint->Width-GRAPH_AREA_RIGHT-GRAPH_AREA_LEFT)
#define GRAPH_AREA_HEIGHT		(GraphPaint->Height-GRAPH_AREA_BOTTOM-GRAPH_AREA_TOP)

#define INFORMATION_CH_COL		0
#define INFORMATION_FILE_COL	1
#define INFORMATION_VAR_COL		2
#define INFORMATION_ADR_COL		3
#define INFORMATION_MARK_COL	4
#define INFORMATION_MODEL_COL	5
#define INFORMATION_SIZE_COL	6
#define INFORMATION_START_COL	7
#define INFORMATION_RANGE_COL	8
#define INFORMATION_NAME_COL	9
#define INFORMATION_YCOEF_COL	10
#define INFORMATION_YUNIT_COL	11
#define INFORMATION_XCOEF_COL	12
#define INFORMATION_XUNIT_COL	13
#define INFORMATION_COLOR_COL	14
#define INFORMATION_WIDTH_COL	15
#define INFORMATION_COMMENT_COL	16

//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"
TGraphForm *GraphForm;

//---------------------------------------------------------------------------

__fastcall TGraphForm::TGraphForm(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
//	Wwŕ`|Cgړ
//---------------------------------------------------------------------------

void __fastcall TGraphForm::MoveToA(int x, int y, int rangeX, int rangeY)
{
	__int64 dataX, dataY;

	if(rangeX > 0 && rangeY > 0){
		dataX = (x*GRAPH_AREA_WIDTH)/rangeX;
		dataY = (y*GRAPH_AREA_HEIGHT)/rangeY;
		GraphPaint->Canvas->MoveTo(GRAPH_AREA_LEFT+dataX, GraphPaint->Height-1-GRAPH_AREA_BOTTOM-dataY);
	}
}

//---------------------------------------------------------------------------
//	Wwŕ`|Cg`悷
//---------------------------------------------------------------------------

void __fastcall TGraphForm::LineToA(int x, int y, int rangeX, int rangeY)
{
	__int64 dataX, dataY;

	if(rangeX > 0 && rangeY > 0){
		dataX = (x*GRAPH_AREA_WIDTH)/rangeX;
		dataY = (y*GRAPH_AREA_HEIGHT)/rangeY;
		GraphPaint->Canvas->LineTo(GRAPH_AREA_LEFT+dataX, GraphPaint->Height-1-GRAPH_AREA_BOTTOM-dataY);
	}
}

//---------------------------------------------------------------------------
//	WwŐ`悷
//---------------------------------------------------------------------------

void __fastcall TGraphForm::LineA(int x1, int y1, int x2, int y2, int rangeX, int rangeY)
{
	MoveToA(x1, y1, rangeX, rangeY);
	LineToA(x2, y2, rangeX, rangeY);
}

//---------------------------------------------------------------------------
//	Wwŕ\
//---------------------------------------------------------------------------

void __fastcall TGraphForm::TextPut(int x, int y, int rangeX, int rangeY, AnsiString str, int xt, int yt)
{
	__int64 dataX, dataY;

	if(rangeX > 0 && rangeY > 0){
		dataX = (x*GRAPH_AREA_WIDTH)/rangeX+xt;
		dataY = (y*GRAPH_AREA_HEIGHT)/rangeY+yt;
		GraphPaint->Canvas->TextOut(GRAPH_AREA_LEFT+dataX, GraphPaint->Height-1-GRAPH_AREA_BOTTOM-dataY, str);
	}
}

//---------------------------------------------------------------------------
//	Ot̕`
//---------------------------------------------------------------------------

void __fastcall TGraphForm::GraphPaintPaint(TObject *Sender)
{
	int XdivLine = graphScale.XLine;
	int YdivLine = graphScale.YLine;
//	int Xdiv = graphScale.XDiv;
//	int Ydiv = graphScale.YDiv;

	GraphPaint->Canvas->Brush->Color = clWhite;
	GraphPaint->Canvas->FillRect(GraphPaint->Canvas->ClipRect);

	__int64 data;


	//XP[`
	GraphPaint->Canvas->Pen->Color = clGray;
	for(int n=0;n <= XdivLine;n++){
		LineA(n, 0, n, 1, XdivLine, 1);
	}
	for(int n=0;n <= YdivLine;n++){
		LineA(0, n, 1, n, 1, YdivLine);
	}

	GraphPaint->Canvas->Pen->Color = clBlack;
	for(int n=0;n <= XdivLine/5;n++){
		LineA(n*5, 0, n*5, 1, XdivLine, 1);
	}
	for(int n=0;n <= YdivLine/5;n++){
		LineA(0, n*5, 1, n*5, 1, YdivLine);
	}


	//f[^`
	for(int m=0;m < GraphGrid->RowCount-1;m++){
		if(graphInfo[m].view == false){
			continue;
		}

		GraphPaint->Canvas->Pen->Color = graphInfo[m].color;
		GraphPaint->Canvas->Pen->Width = graphInfo[m].width;
		GraphPaint->Canvas->Font->Color = graphInfo[m].color;

		if(graphInfo[m].view == true){
			int start = graphInfo[m].rangeStart;
			int size = graphInfo[m].size;
			if(graphInfo[m].rangeSize != 0){
 				size = graphInfo[m].rangeSize;
			}
			if(size+start > graphInfo[m].size){
				size = graphInfo[m].size - start;
			}

			for(int n=0;n < size;n++){
				data = MainForm->GetData(graphInfo[m].adr+(n+start)*graphInfo[m].model, graphInfo[m].model, graphInfo[m].mark);
				if(n==0){
					MoveToA(0, data-graphInfo[m].yPos, XdivLine*graphInfo[m].xDiv, YdivLine*graphInfo[m].yDiv);

				}else if(n <= XdivLine*graphInfo[m].xDiv){
					LineToA(n*graphInfo[m].xCoefficient, data-graphInfo[m].yPos, XdivLine*graphInfo[m].xDiv, YdivLine*graphInfo[m].yDiv);
				}
			}
		}
		GraphPaint->Canvas->Pen->Width = 1;

		TextPut(0, YdivLine , XdivLine, YdivLine, graphInfo[m].name, m*90+30, 20);		//̕`

		if(m < 4){
			for(int n=0;n <= XdivLine;n++){
				TextPut(n, 0, XdivLine, YdivLine, graphInfo[m].xDiv*n, -5, -m*14-6);	//`
			}
			TextPut(XdivLine, 0, XdivLine, YdivLine, graphInfo[m].xUnit, 25, -m*14-6);	//Pʕ`


			for(int n=0;n <= YdivLine;n++){
				if(m < 2){
					TextPut(0, n, XdivLine, YdivLine, graphInfo[m].yDiv*n*graphInfo[m].yCoefficient+graphInfo[m].yPos, -(2-m)*38, 7);

				}else{
					TextPut(XdivLine, n, XdivLine, YdivLine, graphInfo[m].yDiv*n*graphInfo[m].yCoefficient+graphInfo[m].yPos, (m-2)*38+3, 7);
				}
			}
			if(m < 2){
				TextPut(0, YdivLine, XdivLine, YdivLine, graphInfo[m].yUnit, -(2-m)*38, 20);

			}else{
				TextPut(XdivLine, YdivLine, XdivLine, YdivLine, graphInfo[m].yUnit, (m-2)*38+3, 20);
			}
		}
	}

}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::FormShow(TObject *Sender)
{
	GraphGrid->ColWidths[INFORMATION_CH_COL]     = 16;
	GraphGrid->ColWidths[INFORMATION_FILE_COL]   = 80;
	GraphGrid->ColWidths[INFORMATION_VAR_COL]    = 120;
	GraphGrid->ColWidths[INFORMATION_ADR_COL]    = 60;
	GraphGrid->ColWidths[INFORMATION_MARK_COL]   = 18;
	GraphGrid->ColWidths[INFORMATION_MODEL_COL]  = 20;
	GraphGrid->ColWidths[INFORMATION_SIZE_COL]   = 40;
	GraphGrid->ColWidths[INFORMATION_START_COL]  = 40;
	GraphGrid->ColWidths[INFORMATION_RANGE_COL]  = 32;
	GraphGrid->ColWidths[INFORMATION_NAME_COL]   = 100;
	GraphGrid->ColWidths[INFORMATION_YCOEF_COL]  = 40;
	GraphGrid->ColWidths[INFORMATION_YUNIT_COL]  = 50;
	GraphGrid->ColWidths[INFORMATION_XCOEF_COL]  = 40;
	GraphGrid->ColWidths[INFORMATION_XUNIT_COL]  = 50;
	GraphGrid->ColWidths[INFORMATION_COLOR_COL]  = 22;
	GraphGrid->ColWidths[INFORMATION_WIDTH_COL]  = 15;
	GraphGrid->ColWidths[INFORMATION_COMMENT_COL]= 200;

	GraphGrid->Cells[INFORMATION_FILE_COL][0]   = "t@C";
	GraphGrid->Cells[INFORMATION_VAR_COL][0]    = "ϐ";
	GraphGrid->Cells[INFORMATION_MARK_COL][0]   = "";
	GraphGrid->Cells[INFORMATION_ADR_COL][0]    = "AhX";
	GraphGrid->Cells[INFORMATION_MODEL_COL][0]  = "^";
	GraphGrid->Cells[INFORMATION_SIZE_COL][0]   = "TCY";
	GraphGrid->Cells[INFORMATION_START_COL][0]  = "Jn";
	GraphGrid->Cells[INFORMATION_RANGE_COL][0]  = "͈";
	GraphGrid->Cells[INFORMATION_NAME_COL][0]   = "";
	GraphGrid->Cells[INFORMATION_YCOEF_COL][0]  = "xW";
	GraphGrid->Cells[INFORMATION_YUNIT_COL][0]  = "xP";
	GraphGrid->Cells[INFORMATION_XCOEF_COL][0]  = "wW";
	GraphGrid->Cells[INFORMATION_XUNIT_COL][0]  = "wP";
	GraphGrid->Cells[INFORMATION_COLOR_COL][0]  = "RGB";
	GraphGrid->Cells[INFORMATION_WIDTH_COL][0]  = "";
	GraphGrid->Cells[INFORMATION_COMMENT_COL][0]= "Rg";

}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::UpDown2Click(TObject *Sender,
      TUDBtnType Button)
{
	int Ydiv = StrToIntDef(yDivision[((TUpDown *)Sender)->Tag]->Text, 10);
	if(Button == btNext){
		if(Ydiv < 10){
			Ydiv = 10;
		}else if(Ydiv < 20){
			Ydiv = 20;
		}else if(Ydiv < 25){
			Ydiv = 25;
		}else if(Ydiv < 50){
			Ydiv = 50;
		}else if(Ydiv < 100){
			Ydiv = 100;
		}else if(Ydiv < 200){
			Ydiv = 200;
		}else if(Ydiv < 250){
			Ydiv = 250;
		}else if(Ydiv < 500){
			Ydiv = 500;
		}else if(Ydiv < 1000){
			Ydiv = 1000;
		}else if(Ydiv < 2000){
			Ydiv = 2000;
		}else if(Ydiv < 2500){
			Ydiv = 2500;
		}else if(Ydiv < 5000){
			Ydiv = 5000;
		}else if(Ydiv < 10000){
			Ydiv = 10000;
		}
	}else{
		if(Ydiv > 5000){
			Ydiv = 5000;
		}else if(Ydiv > 2500){
			Ydiv = 2500;
		}else if(Ydiv > 2000){
			Ydiv = 2000;
		}else if(Ydiv > 1000){
			Ydiv = 1000;
		}else if(Ydiv > 500){
			Ydiv = 500;
		}else if(Ydiv > 250){
			Ydiv = 250;
		}else if(Ydiv > 200){
			Ydiv = 200;
		}else if(Ydiv > 100){
			Ydiv = 100;
		}else if(Ydiv > 50){
			Ydiv = 50;
		}else if(Ydiv > 25){
			Ydiv = 25;
		}else if(Ydiv > 20){
			Ydiv = 20;
		}else if(Ydiv > 10){
			Ydiv = 10;
		}
	}
	yDivision[((TUpDown *)Sender)->Tag]->Text = IntToStr(Ydiv);

}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::UpDown3Click(TObject *Sender,
      TUDBtnType Button)
{
	int Xdiv = StrToIntDef(xDivision[((TUpDown *)Sender)->Tag]->Text, 10);
	Xdiv=(Xdiv/10)*10;
	if(Button == btNext){
		Xdiv+=10;
	}else{
		Xdiv-=10;
		if(Xdiv <= 1){
			Xdiv=1;
		}
	}
	xDivision[((TUpDown *)Sender)->Tag]->Text = IntToStr(Xdiv);
}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::UpDown13Click(TObject *Sender,
      TUDBtnType Button)
{
	int Ydiv = StrToIntDef(yDivision[((TUpDown *)Sender)->Tag]->Text, 10);
	int Ypos = StrToIntDef(yPosition[((TUpDown *)Sender)->Tag]->Text, 10);
	Ypos=(Ypos/Ydiv)*Ydiv;
	if(Button == btNext){
		Ypos+=Ydiv;
	}else{
		Ypos-=Ydiv;
	}
	yPosition[((TUpDown *)Sender)->Tag]->Text = IntToStr(Ypos);
}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::GraphGridDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
	AnsiString str;

	if(ARow == 0){
		return;
	}

	switch(ACol){
		case INFORMATION_CH_COL:
			((TStringGrid *)Sender)->Canvas->Font->Color = graphInfo[ARow-1].color;
			if(graphInfo[ARow-1].view == true){
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, ARow);
			}else{
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "~");
			}
			break;

		case INFORMATION_FILE_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].fileName);
			break;

		case INFORMATION_VAR_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].varName);
			break;

		case INFORMATION_ADR_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "0x"+IntToHex(graphInfo[ARow-1].adr, 6));
			break;

		case INFORMATION_MARK_COL:
			if(graphInfo[ARow-1].mark == VAR_MARK_USE){
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "}");
			}else{
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "{");
			}
			break;

		case INFORMATION_MODEL_COL:
			if(graphInfo[ARow-1].model == VAR_MODEL_BYTE){
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "a");
			}else if(graphInfo[ARow-1].model == VAR_MODEL_WORD){
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "v");
			}else{
				((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, "k");
			}
			break;

		case INFORMATION_SIZE_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, IntToStr(graphInfo[ARow-1].size));
			break;

		case INFORMATION_START_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, IntToStr(graphInfo[ARow-1].rangeStart));
			break;

		case INFORMATION_RANGE_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, IntToStr(graphInfo[ARow-1].rangeSize));
			break;

		case INFORMATION_NAME_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].name);
			break;

		case INFORMATION_YCOEF_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].yCoefficient);
			break;

		case INFORMATION_YUNIT_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].yUnit);
			break;

		case INFORMATION_XCOEF_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].xCoefficient);
			break;

		case INFORMATION_XUNIT_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].xUnit);
			break;

		case INFORMATION_COLOR_COL:
			str = IntToStr((graphInfo[ARow-1].color & 0xff)*10 /256);
			str = str + IntToStr(((graphInfo[ARow-1].color>>8) & 0xff)*10 /256);
			str = str + IntToStr(((graphInfo[ARow-1].color>>16) & 0xff)*10 /256);
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, str);
			break;

		case INFORMATION_WIDTH_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].width);
			break;

		case INFORMATION_COMMENT_COL:
			((TStringGrid *)Sender)->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top+2, graphInfo[ARow-1].comment);
			break;

	}
}

//---------------------------------------------------------------------------
//	Ot̃Zbg
//---------------------------------------------------------------------------

void __fastcall TGraphForm::SetGraphData(MEM_DATA *mem, int no)
{
	graphInfo[no].view = true;
	graphInfo[no].varName = mem->varName;
	graphInfo[no].fileName = mem->fileName;
	graphInfo[no].adr = mem->adr;
	graphInfo[no].model = mem->model;
	graphInfo[no].mark = mem->mark;
	graphInfo[no].size = mem->size;
	GraphGrid->Repaint();
	GraphPaint->Repaint();

}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::GraphGridKeyPress(TObject *Sender, char &Key)
{
	AnsiString str;
	int model;

	int row = ((TStringGrid *)Sender)->Row;
	int col = ((TStringGrid *)Sender)->Col;

	if(Key == '\r'){
		switch(col){
			case INFORMATION_FILE_COL:
				graphInfo[row-1].fileName = ((TStringGrid *)Sender)->Cells[col][row];
				break;

			case INFORMATION_VAR_COL:
				graphInfo[row-1].varName = ((TStringGrid *)Sender)->Cells[col][row];
				break;

			case INFORMATION_ADR_COL:
				graphInfo[row-1].adr = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 0);
				break;

			case INFORMATION_MARK_COL:
				if(StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 1) != VAR_MARK_NOUSE){
					graphInfo[row-1].mark = VAR_MARK_USE;

				}else{
					graphInfo[row-1].mark = VAR_MARK_NOUSE;
				}
				break;

			case INFORMATION_MODEL_COL:
				model = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 0);
				if(model == VAR_MODEL_BYTE || model == VAR_MODEL_WORD ||  model == VAR_MODEL_DWORD){
					graphInfo[row-1].model = model;
				}
				break;

			case INFORMATION_SIZE_COL:
				graphInfo[row-1].size = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 0);
				break;

			case INFORMATION_START_COL:
				graphInfo[row-1].rangeStart = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 0);
				break;

			case INFORMATION_RANGE_COL:
				graphInfo[row-1].rangeSize = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 0);
				break;

			case INFORMATION_NAME_COL:
				graphInfo[row-1].name = ((TStringGrid *)Sender)->Cells[col][row];
				break;

			case INFORMATION_YCOEF_COL:
				graphInfo[row-1].yCoefficient = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 1);
				break;

			case INFORMATION_YUNIT_COL:
				graphInfo[row-1].yUnit = ((TStringGrid *)Sender)->Cells[col][row];
				break;

			case INFORMATION_XCOEF_COL:
				graphInfo[row-1].xCoefficient = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 1);
				break;

			case INFORMATION_XUNIT_COL:
				graphInfo[row-1].xUnit = ((TStringGrid *)Sender)->Cells[col][row];
				break;

			case INFORMATION_COLOR_COL:
				str= ((TStringGrid *)Sender)->Cells[col][row];
				int color;
				color = (str[1]-'0')*256/10+1;
				color += ((str[2]-'0')*256/10+1)<<8;
				color += ((str[3]-'0')*256/10+1)<<16;
				graphInfo[row-1].color = (TColor)color;
				break;

			case INFORMATION_WIDTH_COL:
				graphInfo[row-1].width = StrToIntDef(((TStringGrid *)Sender)->Cells[col][row], 1);
				break;

			case INFORMATION_COMMENT_COL:
				graphInfo[row-1].comment = ((TStringGrid *)Sender)->Cells[col][row];
				break;
		}
	}
	GraphPaint->Repaint();
}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::GraphGridClick(TObject *Sender)
{
	AnsiString str;

	int row = ((TStringGrid *)Sender)->Row;
	int col = ((TStringGrid *)Sender)->Col;

	switch(col){
		case INFORMATION_FILE_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].fileName;
			break;
		case INFORMATION_VAR_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].varName;
			break;
		case INFORMATION_ADR_COL:
			((TStringGrid *)Sender)->Cells[col][row] = "0x"+IntToHex(graphInfo[row-1].adr, 6);
			break;

		case INFORMATION_MARK_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].mark);
			break;

		case INFORMATION_MODEL_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].model);
			break;

		case INFORMATION_SIZE_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].size);
			break;

		case INFORMATION_START_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].rangeStart);
			break;

		case INFORMATION_RANGE_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].rangeSize);
			break;

		case INFORMATION_NAME_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].name;
			break;

		case INFORMATION_YCOEF_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].yCoefficient);
			break;

		case INFORMATION_YUNIT_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].yUnit;
			break;

		case INFORMATION_XCOEF_COL:
			((TStringGrid *)Sender)->Cells[col][row] = IntToStr(graphInfo[row-1].xCoefficient);
			break;

		case INFORMATION_XUNIT_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].xUnit;
			break;

		case INFORMATION_COLOR_COL:
			str = IntToStr((graphInfo[row-1].color & 0xff)*10 /256);
			str = str + IntToStr(((graphInfo[row-1].color>>8) & 0xff)*10 /256);
			str = str + IntToStr(((graphInfo[row-1].color>>16) & 0xff)*10 /256);
			((TStringGrid *)Sender)->Cells[col][row] = str;
			break;

		case INFORMATION_WIDTH_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].width;
			break;

		case INFORMATION_COMMENT_COL:
			((TStringGrid *)Sender)->Cells[col][row] = graphInfo[row-1].comment;
			break;
	}

}

//---------------------------------------------------------------------------


void __fastcall TGraphForm::Button1Click(TObject *Sender)
{
	GraphGrid->Repaint();
	GraphPaint->Repaint();
}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::GraphGridMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	TGridCoord Cel;
	Cel = ((TStringGrid *)Sender)->MouseCoord(X, Y);
	if(Cel.Y > 0 && Cel.X == 0){
		graphInfo[Cel.Y-1].view = (~graphInfo[Cel.Y-1].view)&0x01;
		((TStringGrid *)Sender)->Repaint();
	}
}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::YdivisionLineChange(TObject *Sender)
{
	int line = StrToIntDef(((TEdit *)Sender)->Text, 0);

	if(((TEdit *)Sender)->Tag < 6){
		if(line < 1){
			line = 10;
		}
		graphInfo[((TEdit *)Sender)->Tag].yDiv = line;

	}else if(((TEdit *)Sender)->Tag < 12){
		if(line < 1){
			line = 10;
		}
		graphInfo[((TEdit *)Sender)->Tag-6].xDiv = line;

	}else if(((TEdit *)Sender)->Tag < 18){
		graphInfo[((TEdit *)Sender)->Tag-12].yPos = line;


	}else if(((TEdit *)Sender)->Tag == 20){
		if(line < 1){
			line = 10;
		}
		graphScale.YLine = line;

	}else if(((TEdit *)Sender)->Tag == 21){
		if(line < 1){
			line = 10;
		}
		graphScale.XLine = line;
	}
	GraphPaint->Repaint();

}

//---------------------------------------------------------------------------

void __fastcall TGraphForm::FormCreate(TObject *Sender)
{
	DoubleBuffered = true;

	yDivision[0] = Ydivision1;
	yDivision[1] = Ydivision2;
	yDivision[2] = Ydivision3;
	yDivision[3] = Ydivision4;
	yDivision[4] = Ydivision5;
	yDivision[5] = Ydivision6;

	xDivision[0] = Xdivision1;
	xDivision[1] = Xdivision2;
	xDivision[2] = Xdivision3;
	xDivision[3] = Xdivision4;
	xDivision[4] = Xdivision5;
	xDivision[5] = Xdivision6;

	yPosition[0] = Yposition1;
	yPosition[1] = Yposition2;
	yPosition[2] = Yposition3;
	yPosition[3] = Yposition4;
	yPosition[4] = Yposition5;
	yPosition[5] = Yposition6;

}

//---------------------------------------------------------------------------

