//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\inifiles.hpp>
#include <process.h>
#pragma hdrstop

#include <winbase.h>

#include "Main.h"
#include "Write.h"
#include "abort.h"
#include "Thread.h"
#include "terminal.h"
#include "Graph.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------

__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}

#define RAM_VIEW_DATA_TOP 7

//---------------------------------------------------------------------------
//	ϐ̌
//---------------------------------------------------------------------------

int __fastcall TMainForm::FindVar(AnsiString name,AnsiString file, struct MEM_DATA *mem)
{
	if(name == ""){
		return(false);
	}
	for(int n=0;n < memDataSize;n++){
		if(memData[n].varName == name && memData[n].fileName == file){
			*mem = memData[n];
			return(true);
		}
	}
	return(false);
}

//---------------------------------------------------------------------------
//	AhXt@Cǂݍ
//	name :AvP[Vt@C
//	name2:I/O`ꂽAhXt@C
//---------------------------------------------------------------------------

int __fastcall TMainForm::AdrFileRead(AnsiString name, AnsiString name2)
{
	TStringList *adrFile, *tmp;

	if(FileExists(name) == false){
		return(false);
	}

	adrFile = new TStringList;
	adrFile->LoadFromFile(name);
	adrFile->Delete(0);

	if(FileExists(name2) == true){
		tmp = new TStringList;
		tmp->LoadFromFile(name2);
		tmp->Delete(0);
		for(int n= 0;n < tmp->Count;n++){
			adrFile->Add(tmp->Strings[n]);
		}
		delete tmp;
	}


	for(int n=0;n < adrFile->Count;n++){
		memData[n].varName = adrFile->Strings[n].SubString(1, 31).Trim();
		if(adrFile->Strings[n].SubString(33, 2) == "+-"){
			memData[n].mark = 1;
		}else{
			memData[n].mark = 0;
		}
		if(adrFile->Strings[n].SubString(36, 4) == "char"){
			memData[n].model = 1;
		}else if(adrFile->Strings[n].SubString(36, 5) == "short"){
			memData[n].model = 2;
		}else if(adrFile->Strings[n].SubString(36, 4) == "long"){
			memData[n].model = 4;
		}else{
			memData[n].model = 1;
		}
		memData[n].adr = ("0x"+adrFile->Strings[n].SubString(46, 6)).ToIntDef(0) & memRange[0].size;
		memData[n].size = adrFile->Strings[n].SubString(53, 7).ToIntDef(1)/memData[n].model;
		memData[n].section =  adrFile->Strings[n].SubString(61, 7);
		memData[n].fileName = adrFile->Strings[n].SubString(69, 31).LowerCase().Trim();
		memData[n].fileName = ChangeFileExt(ExtractFileName(memData[n].fileName), "");

		if(memData[n].adr >= memRange[0].romTop && memData[n].adr <= memRange[0].romEnd){
			memData[n].area = MEM_DATA_AREA_ROM;

		}else if(memData[n].adr >= memRange[1].romTop && memData[n].adr <= memRange[1].romEnd){
			memData[n].area = MEM_DATA_AREA_ROM;

		}else if(memData[n].adr >= memRange[0].ramTop && memData[n].adr <= memRange[0].ramEnd){
			memData[n].area = MEM_DATA_AREA_RAM;

		}else if(memData[n].adr >= memRange[1].ramTop && memData[n].adr <= memRange[1].ramEnd){
			memData[n].area = MEM_DATA_AREA_RAM;

		}else if(memData[n].adr >= memRange[0].ioTop && memData[n].adr <= memRange[0].ioEnd){
			memData[n].area = MEM_DATA_AREA_IO;

		}else if(memData[n].adr >= memRange[1].ioTop && memData[n].adr <= memRange[1].ioEnd){
			memData[n].area = MEM_DATA_AREA_IO;

		}else{
			memData[n].area = MEM_DATA_AREA_ETC;

		}

	}
	memDataSize = adrFile->Count;
	RamView->RowCount = adrFile->Count+2;



	int mode[2] = {SORT_MODE_ADDRESS_UP, SORT_MODE_FILE_NAME_NON};
	SortData(mode);

	for(int y=1;y < RangeGrid->RowCount;y++){
		for(int x=0;x < RangeGrid->ColCount;x++){
			RangeGrid->Cells[x][y] = "";
		}
	}

	GetAdrRange();
	for(int n=0;n < READ_RANGE_MAX_SIZE && readRange.range[n].area != 0;n++){
		if(readRange.range[n].area == MEM_DATA_AREA_ROM){
			RangeGrid->Cells[0][1+n] = "ROM";
		}else if(readRange.range[n].area == MEM_DATA_AREA_RAM){
			RangeGrid->Cells[0][1+n] = "RAM";
		}else if(readRange.range[n].area == MEM_DATA_AREA_IO){
			RangeGrid->Cells[0][1+n] = "IO";
		}else{
			RangeGrid->Cells[0][1+n] = "ETC";
		}
		RangeGrid->Cells[1][1+n] = "0x"+IntToHex(readRange.range[n].top, memRange[0].width);
		RangeGrid->Cells[2][1+n] = "0x"+IntToHex(readRange.range[n].end, memRange[0].width);
		RangeGrid->Cells[3][1+n] = IntToStr(readRange.range[n].end-readRange.range[n].top+1);
	}

	SortData(sortMode);
	RamView->Repaint();


 	delete adrFile;

	struct MEM_DATA mem;
	for(int n=0;n < 6;n++){
		if(FindVar(GraphForm->graphInfo[n].varName, GraphForm->graphInfo[n].fileName, &mem) == true){
			GraphForm->SetGraphData(&mem, n);
		}
	}

	return(true);
}

//---------------------------------------------------------------------------
//	AhXt@Cƒ`t@Cǂݍ
//	Ât@Cinit@C͕ۑ
//---------------------------------------------------------------------------

void __fastcall TMainForm::SrcFileRead(AnsiString name, AnsiString oldName)
{
	if(FileExists(oldName) == true){
		SaveIniFile(ChangeFileExt(oldName,".ini"));
//		ShowMessage(oldName);
	}
	LoadIniFile(ChangeFileExt(name,".ini"));
//	ShowMessage(ChangeFileExt(name,".ini"));
	if(AdrFileRead(ChangeFileExt(name, ".adr"), ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+".adr")){
		Application->Title = ExtractFileName(name);
		Caption = name;

	}else{
		ShowMessage("t@CJ܂");
	}
}

//---------------------------------------------------------------------------
//	RS232J
//---------------------------------------------------------------------------

HANDLE __fastcall TMainForm::OpenComPort(AnsiString port, int speed)
{
	HANDLE handle;
	DCB dcbCom;
	COMMTIMEOUTS tout;

	handle = CreateFile(port.c_str(),GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, 0);
 	if(handle == HANDLE(-1)){
		return(0);
	}

	//M^CAEg[ms]=ReadTotalTimeoutMultiplier~MoCg+ReadTotalTimeoutConstant
	//M^CAEg[ms]=writeTotalTimeoutMultiplier~MoCg+writeTotalTimeoutConstant
	tout.ReadIntervalTimeout = 0;
	tout.ReadTotalTimeoutMultiplier = 0;
	tout.ReadTotalTimeoutConstant = 50;
	tout.WriteTotalTimeoutMultiplier = 0;
	tout.WriteTotalTimeoutConstant = 0;
	SetCommTimeouts(handle, &tout);

	GetCommState(handle, &dcbCom);
	dcbCom.fDtrControl = DTR_CONTROL_DISABLE;
	dcbCom.fDsrSensitivity = false;
	dcbCom.fRtsControl =  RTS_CONTROL_DISABLE;
	dcbCom.fAbortOnError = false;
	dcbCom.fOutxCtsFlow = false;
	dcbCom.fOutxDsrFlow = false;
	dcbCom.BaudRate = speed;
	dcbCom.ByteSize = 8;
	dcbCom.StopBits = TWOSTOPBITS;
	if(ComParityBox->Text == ""){
		dcbCom.Parity = EVENPARITY;
	}else if(ComParityBox->Text == ""){
		dcbCom.Parity = ODDPARITY;
	}else{
		dcbCom.Parity = NOPARITY;
	}
	SetCommState(handle, &dcbCom);

	return(handle);
}

//---------------------------------------------------------------------------
//	[obt@[f[^擾	
//---------------------------------------------------------------------------

__int64 __fastcall TMainForm::GetData(int adr, int model, int mark)
{
	__int64 data;
	adr = adr & 0xffffff;

	if(model == VAR_MODEL_BYTE){
		if(mark == VAR_MARK_USE){
			data = (char)memBuf[adr];
		}else{
			data = (UCHAR)memBuf[adr];
		}
	}else if(model == VAR_MODEL_WORD){
		if(mark == VAR_MARK_USE){
			data = (short)((memBuf[adr] << 8) | memBuf[adr+1]);
		}else{
			data = (USHORT)((memBuf[adr] << 8) | memBuf[adr+1]);
		}

	}else if(model == VAR_MODEL_DWORD){
		if(mark == VAR_MARK_USE){
			data = (int)((memBuf[adr] << 24) | (memBuf[adr+1] << 16) | (memBuf[adr+2] << 8) | memBuf[adr+3]);
		}else{
			data = (UINT)((memBuf[adr] << 24) | (memBuf[adr+1] << 16) | (memBuf[adr+2] << 8) | memBuf[adr+3]);
		}
	}
	return(data);
}

//---------------------------------------------------------------------------
//	init@C̃[h
//---------------------------------------------------------------------------

void __fastcall TMainForm::LoadIniFile(AnsiString name, int mode)
{

	if(mode == 0 && FileExists(name) == false){
		return;
	}

	TIniFile *iniFile;

	iniFile = new TIniFile(name);

	ComPortBox->Text = iniFile->ReadString("ʐMݒ","|[g","COM1");
	ComSpeedBox->Text = iniFile->ReadString("ʐMݒ","x","38400");
	ComParityBox->Text = iniFile->ReadString("ʐMݒ","peB","");

	Check10->Checked = iniFile->ReadBool("\","POi",0);
	Check2->Checked = iniFile->ReadBool("\","Qi",0);
	SetUpPanelChk->Checked = iniFile->ReadBool("\","ݒ",0);

	MpuGroupBox->Text = iniFile->ReadString("}CR","O[v","");
	if(MpuGroupBox->Text !=""){
		TObject *Sender;
		MpuGroupBoxChange(Sender);
		MpuBox->Text = iniFile->ReadString("}CR","}CR","");
		MpuBoxChange(Sender);
	}

	WriterFileNameEdit->Text = iniFile->ReadString("C^[","\tg","");
	WriterComOptionEdit->Text = iniFile->ReadString("C^[","|[gIvV","");
	WriterOptionEdit->Text = iniFile->ReadString("C^[","IvV","");

	TerminalCheck->Checked = iniFile->ReadBool("\","^[~i",0);
	TerminalForm->Left = iniFile->ReadInteger("^[~i{","",0);
	TerminalForm->Top = iniFile->ReadInteger("^[~i{","",0);
	TerminalForm->Width = iniFile->ReadInteger("^[~i{","",640);
	TerminalForm->Height = iniFile->ReadInteger("^[~i{","",400);

	GraphPanelChk->Checked = iniFile->ReadBool("\","Ot",0);
	GraphForm->Left = iniFile->ReadInteger("Ot{","",0);
	GraphForm->Top = iniFile->ReadInteger("Ot{","",0);
	GraphForm->Width = iniFile->ReadInteger("Ot{","",640);
	GraphForm->Height = iniFile->ReadInteger("Ot{","",350);

	GraphForm->graphScale.XLine = iniFile->ReadInteger("Ot","w{",10);
	GraphForm->XdivisionLine->Text = GraphForm->graphScale.XLine;
	GraphForm->graphScale.YLine = iniFile->ReadInteger("Ot","x{",10);
	GraphForm->YdivisionLine->Text = GraphForm->graphScale.YLine;

	for(int n=0;n < 6;n++){
		GraphForm->graphInfo[n].fileName     = iniFile->ReadString("OtCH"+IntToStr(n+1), "t@C", "").LowerCase();
		GraphForm->graphInfo[n].fileName     = ChangeFileExt(ExtractFileName(GraphForm->graphInfo[n].fileName), "");
		GraphForm->graphInfo[n].varName      = iniFile->ReadString("OtCH"+IntToStr(n+1), "ϐ", "");
		GraphForm->graphInfo[n].mark         = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "", 1);
		GraphForm->graphInfo[n].adr          = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "AhX", 0);
		GraphForm->graphInfo[n].model        = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "^", 1);
		GraphForm->graphInfo[n].size         = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "TCY", 0);
		GraphForm->graphInfo[n].rangeStart   = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "͈̓X^[g", 0);
		GraphForm->graphInfo[n].rangeSize    = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "͈̓TCY", 0);
		GraphForm->graphInfo[n].name         = iniFile->ReadString("OtCH"+IntToStr(n+1), "", "");
		GraphForm->graphInfo[n].yCoefficient = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "xW", 1);
		GraphForm->graphInfo[n].yUnit        = iniFile->ReadString("OtCH"+IntToStr(n+1), "xP", "");
		GraphForm->graphInfo[n].xCoefficient = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "wW", 1);
		GraphForm->graphInfo[n].xUnit        = iniFile->ReadString("OtCH"+IntToStr(n+1), "wP", "");
		GraphForm->graphInfo[n].xDiv         = iniFile->ReadInteger("OtCH"+IntToStr(n+1),"wDIV",10);
		GraphForm->xDivision[n]->Text        = GraphForm->graphInfo[n].xDiv;
		GraphForm->graphInfo[n].yDiv         = iniFile->ReadInteger("OtCH"+IntToStr(n+1),"xDIV",100);
		GraphForm->yDivision[n]->Text        = GraphForm->graphInfo[n].yDiv;
		GraphForm->graphInfo[n].yPos         = iniFile->ReadInteger("OtCH"+IntToStr(n+1),"xPOS",0);
		GraphForm->yPosition[n]->Text        = GraphForm->graphInfo[n].yPos;
		GraphForm->graphInfo[n].color        = (TColor)StrToInt(iniFile->ReadString("OtCH"+IntToStr(n+1), "\F", "-1"));
		GraphForm->graphInfo[n].width        = iniFile->ReadInteger("OtCH"+IntToStr(n+1), "", 1);
		GraphForm->graphInfo[n].comment      = iniFile->ReadString("OtCH"+IntToStr(n+1), "Rg", "");
	}

	AutoMpuReadCheck->Checked = true;

	if(mode == 1){
		Left = iniFile->ReadInteger("{","",0);
		Top = iniFile->ReadInteger("{","",0);
		Width = iniFile->ReadInteger("{","",640);
		Height = iniFile->ReadInteger("{","",450);

		srcFile = "";
		srcFileName[0] = iniFile->ReadString("","t@CP","");

		WindowState = (TWindowState)iniFile->ReadInteger("{","[h",0);

		for(int n=0;n < 6;n++){
			GraphForm->graphInfo[n].yCoefficient = 1;
			GraphForm->graphInfo[n].xCoefficient = 1;
		}
	}

	delete iniFile;

}

//---------------------------------------------------------------------------
//	init@C̕ۑ
//---------------------------------------------------------------------------

void __fastcall TMainForm::SaveIniFile(AnsiString name, int mode)
{
	TIniFile *iniFile;

	iniFile = new TIniFile(name);


	iniFile->WriteString("ʐMݒ","|[g",ComPortBox->Text);
	iniFile->WriteString("ʐMݒ","x",ComSpeedBox->Text);
	iniFile->WriteString("ʐMݒ","peB",ComParityBox->Text);

	iniFile->WriteBool("\","POi",Check10->Checked);
	iniFile->WriteBool("\","Qi",Check2->Checked);
	iniFile->WriteBool("\","ݒ",SetUpPanelChk->Checked);

	iniFile->WriteString("}CR","O[v",MpuGroupBox->Text);
	iniFile->WriteString("}CR","}CR",MpuBox->Text);

	iniFile->WriteString("C^[","\tg",WriterFileNameEdit->Text);
	iniFile->WriteString("C^[","|[gIvV",WriterComOptionEdit->Text);
	iniFile->WriteString("C^[","IvV",WriterOptionEdit->Text);

	iniFile->WriteBool("\","^[~i",TerminalCheck->Checked);
	iniFile->WriteInteger("^[~i{","",TerminalForm->Left);
	iniFile->WriteInteger("^[~i{","",TerminalForm->Top);
	iniFile->WriteInteger("^[~i{","",TerminalForm->Width);
	iniFile->WriteInteger("^[~i{","",TerminalForm->Height);

	iniFile->WriteBool("\","Ot",GraphPanelChk->Checked);
	iniFile->WriteInteger("Ot{", "",GraphForm->Left);
	iniFile->WriteInteger("Ot{", "",GraphForm->Top);
	iniFile->WriteInteger("Ot{", "",GraphForm->Width);
	iniFile->WriteInteger("Ot{", "",GraphForm->Height);

	iniFile->WriteInteger("Ot", "w{",GraphForm->graphScale.XLine);
	iniFile->WriteInteger("Ot", "x{",GraphForm->graphScale.YLine);

	for(int n=0;n < 6;n++){
		iniFile->WriteString("OtCH" +IntToStr(n+1), "t@C",GraphForm->graphInfo[n].fileName);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "ϐ",GraphForm->graphInfo[n].varName);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "AhX","0x"+IntToHex(GraphForm->graphInfo[n].adr, 6));
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "",GraphForm->graphInfo[n].mark);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "^",GraphForm->graphInfo[n].model);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "TCY",GraphForm->graphInfo[n].size);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "͈̓X^[g",GraphForm->graphInfo[n].rangeStart);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "͈̓TCY",GraphForm->graphInfo[n].rangeSize);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "",GraphForm->graphInfo[n].name);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "xW",GraphForm->graphInfo[n].yCoefficient);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "xP",GraphForm->graphInfo[n].yUnit);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "wW",GraphForm->graphInfo[n].xCoefficient);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "wP",GraphForm->graphInfo[n].xUnit);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "wDIV",GraphForm->graphInfo[n].xDiv);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "xDIV",GraphForm->graphInfo[n].yDiv);
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "xPOS",GraphForm->graphInfo[n].yPos);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "\F","0x"+IntToHex(GraphForm->graphInfo[n].color, 6));
		iniFile->WriteInteger("OtCH"+IntToStr(n+1), "",GraphForm->graphInfo[n].width);
		iniFile->WriteString("OtCH" +IntToStr(n+1), "Rg",GraphForm->graphInfo[n].comment);
	}

	if(mode == 1){
		iniFile->WriteInteger("{","[h",(int)WindowState);

		iniFile->WriteInteger("{","",Left);
		iniFile->WriteInteger("{","",Top);
		iniFile->WriteInteger("{","",Width);
		iniFile->WriteInteger("{","",Height);

		iniFile->WriteString("","t@CP",srcFileName[0]);
	}

	delete iniFile;
}

//---------------------------------------------------------------------------
//	\[g
//---------------------------------------------------------------------------

void __fastcall TMainForm::SortData(int *mode)
{
	struct MEM_DATA tmp;

	//GA(ROM,RAM,I/O,ETC)Ń\[g
	for(int n=0;n < memDataSize;n++){
		for(int m=1;n+m < memDataSize;m++){
			if(memData[n].area > memData[n+m].area){
				tmp = memData[n];
				memData[n] = memData[n+m];
				memData[n+m] = tmp;
			}
		}
	}

	//t@CŃ\[g
	if(mode[1] == SORT_MODE_FILE_NAME_UP){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(memData[n].fileName > memData[n+m].fileName){
					tmp = memData[n];
					memData[n] = memData[n+m];
					memData[n+m] = tmp;
				}
			}
		}
	}else if(mode[1] == SORT_MODE_FILE_NAME_DOWN){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(memData[n].fileName < memData[n+m].fileName){
					tmp = memData[n];
					memData[n] = memData[n+m];
					memData[n+m] = tmp;
				}
			}
		}
	}

	//AhXAϐŃ\[g
	if(mode[0] == SORT_MODE_ADDRESS_UP){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(mode[1] != SORT_MODE_FILE_NAME_NON && memData[n].fileName != memData[n+m].fileName){
					break;
				}
				if(memData[n].adr > memData[n+m].adr){
						tmp = memData[n];
						memData[n] = memData[n+m];
						memData[n+m] = tmp;
			   	}
			}
		}
	}else if(mode[0] == SORT_MODE_ADDRESS_DOWN){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(mode[1] != SORT_MODE_FILE_NAME_NON && memData[n].fileName != memData[n+m].fileName){
					break;
				}
				if(memData[n].adr < memData[n+m].adr){
						tmp = memData[n];
						memData[n] = memData[n+m];
						memData[n+m] = tmp;
			   	}
			}
		}
	}else if(mode[0] == SORT_MODE_VAR_NAME_UP){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(mode[1] != SORT_MODE_FILE_NAME_NON  && memData[n].fileName != memData[n+m].fileName){
					break;
				}
				if(memData[n].varName > memData[n+m].varName){
						tmp = memData[n];
						memData[n] = memData[n+m];
						memData[n+m] = tmp;
			   	}
			}
		}
	}else if(mode[0] == SORT_MODE_VAR_NAME_DOWN){
		for(int n=0;n < memDataSize;n++){
			for(int m=1;n+m < memDataSize;m++){
				if(memData[n].area != memData[n+m].area){
					break;
				}
				if(mode[1] != SORT_MODE_FILE_NAME_NON  && memData[n].fileName != memData[n+m].fileName){
					break;
				}
				if(memData[n].varName < memData[n+m].varName){
						tmp = memData[n];
						memData[n] = memData[n+m];
						memData[n+m] = tmp;
			   	}
			}
		}
	}
}

//---------------------------------------------------------------------------
//	O[vt@C̓Ǎ
//---------------------------------------------------------------------------

void __fastcall TMainForm::MpuGroupBoxChange(TObject *Sender)
{
	TIniFile *iniFile;

	iniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"def\\"+"MpuGroup.def");

	MpuBox->Clear();
	iniFile->ReadSection(MpuGroupBox->Text, MpuBox->Items);

	delete iniFile;
}

//---------------------------------------------------------------------------
//	gpĂ郁[̈O[v͈͂o^
//---------------------------------------------------------------------------

void __fastcall TMainForm::GetAdrRange(void)
{
	for(int n=0;n < READ_RANGE_MAX_SIZE;n++){
			readRange.range[n].top = 0;
			readRange.range[n].end = 0;
			readRange.range[n].area = 0;
	}
	int m=-1;
	for(int n=0;n < memDataSize && m < READ_RANGE_MAX_SIZE;n++){
		if(memData[n].size == 0){

		}else if(readRange.range[m].area != memData[n].area || m==-1){
			m++;
			readRange.range[m].top = memData[n].adr;
			readRange.range[m].end = (memData[n].adr+memData[n].size*memData[n].model-1) | 0x0001;
			readRange.range[m].area = memData[n].area;

		}else if(readRange.range[m].end+1 >= memData[n].adr){
			readRange.range[m].end = (memData[n].adr+memData[n].size*memData[n].model-1) | 0x0001;

		}else{
			m++;
			readRange.range[m].top = memData[n].adr;
			readRange.range[m].end = (memData[n].adr+memData[n].size*memData[n].model-1) | 0x0001;
			readRange.range[m].area = memData[n].area;

		}
	}
	readRange.size = m+1;
	SetReadAreaPermit();
}

//---------------------------------------------------------------------------
//	ǂݍ݂̋ݒ肷
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetReadAreaPermit(void)
{
	for(int n=0;n < readRange.size;n++){
		if(readRange.range[n].area == MEM_DATA_AREA_ROM){
			readRange.range[n].permit = RomReadChk->Checked;

		}else if(readRange.range[n].area == MEM_DATA_AREA_RAM){
			readRange.range[n].permit = RamReadChk->Checked;

		}else if(readRange.range[n].area == MEM_DATA_AREA_IO){
			readRange.range[n].permit = IOReadChk->Checked;

		}else if(readRange.range[n].area == MEM_DATA_AREA_ETC){
			readRange.range[n].permit = EtcReadChk->Checked;

		}
	}

}

//---------------------------------------------------------------------------
//	݃R}h̑M
//---------------------------------------------------------------------------

void __fastcall TMainForm::MpuWriteCommand(int size, int adr, UINT data)
{
	UCHAR tx[8], rx[64];
	DWORD len;

	tx[0] = size;
	tx[1] = ((adr>>14)&0x7f)|0x80;
	tx[2] = ((adr>>7) &0x7f)|0x80;
	tx[3] = ((adr>>0) &0x7f)|0x80;
	switch(size){
		case 1:
			tx[4] = ((data>>7)&0x7f)|0x80;
			tx[5] = ((data>>0)&0x7f)|0x80;
			tx[6] = '\r';
			WriteFile(handleCom, tx, 7, &len, NULL);
			break;

		case 2:
			tx[4] = ((data>>14)&0x7f)|0x80;
			tx[5] = ((data>>7) &0x7f)|0x80;
			tx[6] = ((data>>0) &0x7f)|0x80;
			tx[7] = '\r';
			WriteFile(handleCom, tx, 8, &len, NULL);
			break;

		case 4:
			tx[4] = ((data>>28)&0x7f)|0x80;
			tx[5] = ((data>>21)&0x7f)|0x80;
			tx[6] = ((data>>14)&0x7f)|0x80;
			tx[7] = ((data>>7) &0x7f)|0x80;
			tx[8] = ((data>>0) &0x7f)|0x80;
			tx[9]= '\r';
			WriteFile(handleCom, tx, 10, &len, NULL);
			break;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::MpuBoxChange(TObject *Sender)
{
	TIniFile *iniFile;

	iniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+".def");

	memRange[0].size  = iniFile->ReadInteger("MEM_RANGE","MEM_SIZE",0);
	memRange[0].romTop= iniFile->ReadInteger("MEM_RANGE","ROM1_TOP",0);
	memRange[0].romEnd= iniFile->ReadInteger("MEM_RANGE","ROM1_END",0);
	memRange[1].romTop= iniFile->ReadInteger("MEM_RANGE","ROM2_TOP",0);
	memRange[1].romEnd= iniFile->ReadInteger("MEM_RANGE","ROM2_END",0);
	memRange[0].ramTop= iniFile->ReadInteger("MEM_RANGE","RAM1_TOP",0);
	memRange[0].ramEnd= iniFile->ReadInteger("MEM_RANGE","RAM1_END",0);
	memRange[1].ramTop= iniFile->ReadInteger("MEM_RANGE","RAM2_TOP",0);
	memRange[1].ramEnd= iniFile->ReadInteger("MEM_RANGE","RAM2_END",0);
	memRange[0].ioTop = iniFile->ReadInteger("MEM_RANGE","IO1_TOP",0);
	memRange[0].ioEnd = iniFile->ReadInteger("MEM_RANGE","IO1_END",0);
	memRange[1].ioTop = iniFile->ReadInteger("MEM_RANGE","IO2_TOP",0);
	memRange[1].ioEnd = iniFile->ReadInteger("MEM_RANGE","IO2_END",0);

	delete iniFile;

	int size=4;
	if(memRange[0].size > 0xfffffff){
		size = 8;
	}else if(memRange[0].size > 0xffffff){
		size = 7;
	}else if(memRange[0].size > 0xfffff){
		size = 6;
	}else if(memRange[0].size > 0xffff){
		size = 5;
	}
	memRange[0].width = size;

	int count=0;

	for(int y=1;y < MemRangeGrid->RowCount;y++){
		for(int x=0;x < MemRangeGrid->ColCount;x++){
			MemRangeGrid->Cells[x][y] = "";
		}
	}
	if(memRange[0].romEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "ROM1";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[0].romTop, size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[0].romEnd, size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[0].romEnd-memRange[0].romTop+1);
		count++;
	}

	if(memRange[1].romEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "ROM2";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[1].romTop, size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[1].romEnd, size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[1].romEnd-memRange[1].romTop+1);
		count++;
	}

	if(memRange[0].ramEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "RAM1";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[0].ramTop, size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[0].ramEnd, size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[0].ramEnd-memRange[0].ramTop+1);
		count++;
	}

	if(memRange[1].ramEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "RAM2";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[1].ramTop, size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[1].ramEnd, size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[1].ramEnd-memRange[1].ramTop+1);
		count++;
	}

	if(memRange[0].ioEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "IO1";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[0].ioTop,  size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[0].ioEnd,  size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[0].ioEnd-memRange[0].ioTop+1);
		count++;
	}

	if(memRange[1].ioEnd!=0){
		MemRangeGrid->Cells[0+0][1+count] = "IO2";
		MemRangeGrid->Cells[1+0][1+count] = "0x"+IntToHex(memRange[1].ioTop,  size);
		MemRangeGrid->Cells[1+1][1+count] = "0x"+IntToHex(memRange[1].ioEnd,  size);
		MemRangeGrid->Cells[1+2][1+count] = IntToStr(memRange[1].ioEnd-memRange[1].ioTop+1);
		//count++;
	}

	AdrFileRead(ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+"-mem.adr", ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+".adr");

}

//---------------------------------------------------------------------------

void __fastcall TMainForm::ConnectChkClick(TObject *Sender)
{
	if(ConnectChk->Checked == false){
		if(comThread){
			comThread->Terminate();
		}

		CloseHandle(handleCom);

	}else{
		handleCom = OpenComPort(ComPortBox->Text, StrToIntDef(ComSpeedBox->Text, -1));
		if(handleCom == 0){
			ConnectChk->Checked = false;
			ShowMessage(ComPortBox->Text+"J܂");

		}else{
			comThread = new ComThread(true);
			comThread->FreeOnTerminate = true;
			comThread->Resume();
		}
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::MenuItem1Click(TObject *Sender)
{
	if(popupPosMark == 0){
		for(int n=0;n < memDataSize;n++){
			memData[n].mark = ((TMenuItem *)Sender)->Tag;
		}
	}else{
		memData[popupPosMark-1].mark = ((TMenuItem *)Sender)->Tag;
	}
	RamView->Repaint();
}


//---------------------------------------------------------------------------

void __fastcall TMainForm::L1Click(TObject *Sender)
{
	OpenDialog1->FileName = srcFileName[0];
	if(OpenDialog1->Execute() == true){
		AnsiString old = srcFile;
		srcFileName[0] = srcFile = OpenDialog1->FileName;
		OldSrcName1->Caption = srcFileName[0]+"(&1)";
		SrcFileRead(srcFile, old);
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::OldSrcName1Click(TObject *Sender)
{
	SrcFileRead(srcFileName[0], srcFile);
	srcFile = srcFileName[0];
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
	Close();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::About1Click(TObject *Sender)
{
	AboutBox->ShowModal();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::SetUpPanelChkClick(TObject *Sender)
{
	SetUpPanel->Visible = SetUpPanelChk->Checked;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::GraphPanelChkClick(TObject *Sender)
{
	SetWindowPos(GraphForm->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
//	GraphForm->Show();
	GraphForm->Visible = ((TCheckBox *)Sender)->Checked;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::WriterFileNameButtonClick(TObject *Sender)
{
	WriterOpenDialog->InitialDir = ExtractFilePath(WriterFileNameEdit->Text);
	if(WriterOpenDialog->Execute() == true){
		WriterFileNameEdit->Text = WriterOpenDialog->FileName;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	SaveIniFile(ChangeFileExt(Application->ExeName, ".ini"), 1);
	SaveIniFile(ChangeFileExt(srcFile, ".ini"), 0);

	if(comThread){
		comThread->Terminate();
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::W1Click(TObject *Sender)
{
	ULONG stat;
	LPDWORD modemStat;
	AnsiString prg;

	if(WriterFileNameEdit->Text == ""){
		ShowMessage("ΉĂ܂");
		return;
	}

	prg = WriterFileNameEdit->Text;

	SrcFileRead(srcFileName[0], srcFileName[0]);

	if(comThread){
		comThread->Terminate();
	}
	Sleep(500);
	if(ConnectChk->Checked == true){
		CloseHandle(handleCom);
	}

	Sleep(500);

//	ShowMessage("["+prg+"]["+WriterComOptionEdit->Text+ComPortBox->Text+"]["+WriterOptionEdit->Text+"]["+ChangeFileExt(srcFileName[0], ".Mot")+"]");
	if(spawnl(P_WAIT, prg.c_str(), prg.c_str(), (WriterComOptionEdit->Text+ComPortBox->Text).c_str(), WriterOptionEdit->Text.c_str(), ChangeFileExt(srcFileName[0], ".Mot").c_str(), NULL) != 0){
		ShowMessage("݂Ɏs܂B");
	}

	handleCom = OpenComPort(ComPortBox->Text, StrToIntDef(ComSpeedBox->Text, -1));
	EscapeCommFunction(handleCom, CLRRTS);
	EscapeCommFunction(handleCom, SETDTR);
	Sleep(50);
	EscapeCommFunction(handleCom, CLRDTR);

	if(ConnectChk->Checked == true){
		comThread = new ComThread(true);
		comThread->FreeOnTerminate = true;
		comThread->Resume();
	}else{
		CloseHandle(handleCom);
	}

}

//---------------------------------------------------------------------------

void __fastcall TMainForm::BYTE1Click(TObject *Sender)
{
	memData[popupPos-1].model = ((TMenuItem *)Sender)->Tag;
	RamView->Repaint();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::Check10Click(TObject *Sender)
{
	RamView->Repaint();
}

//---------------------------------------------------------------------------


void __fastcall TMainForm::R1Click(TObject *Sender)
{
	if(ConnectChk->Checked == false){
		handleCom = OpenComPort(ComPortBox->Text, StrToIntDef(ComSpeedBox->Text, -1));
	}

	EscapeCommFunction(handleCom, SETDTR);
	Sleep(50);
	EscapeCommFunction(handleCom, CLRDTR);

	if(ConnectChk->Checked == false){
		CloseHandle(handleCom);
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::RamViewDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
	__int64 Data;
	UINT Adr;
	static int count;
	AnsiString Str;

	if(ARow == 0 && ACol == 0){
		StatusBar->Panels->Items[0]->Text = count++;
	}

	if(ARow >= 1 && ACol >= 1 && ACol < RamView->FixedCols){
		//RamView->Canvas->Brush->Color = clInfoBk;
		RamView->Canvas->Brush->Color = clWindow;
		//Rect.Right++;
		//Rect.Bottom++;
		RamView->Canvas->FillRect(Rect);
	}
	if(ARow == 0){
		switch(ACol){
		  case 0:
			if(sortMode[0] == SORT_MODE_ADDRESS_UP){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "Ԓn");
			}else if(sortMode[0] == SORT_MODE_ADDRESS_DOWN){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "Ԓn");
			}else{
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "@Ԓn");
			}
			break;
		  case 1:
			if(sortMode[1] == SORT_MODE_FILE_NAME_NON){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "@t@C");
			}else if(sortMode[1] == SORT_MODE_FILE_NAME_UP){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "t@C");
			}else{
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "t@C");
			}
			break;
		  case 2:
			if(sortMode[0] == SORT_MODE_VAR_NAME_UP){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "ϐ");
			}else if(sortMode[0] == SORT_MODE_VAR_NAME_DOWN){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "ϐ");
			}else{
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "@ϐ");
			}
			break;
		  case 3:
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "");
			break;
		  case 4:
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "^");
			break;
		  case 5:
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "size");
			break;
		  case 6:
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "section");
			break;
		  default:
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, " ["+IntToStr(ACol-RAM_VIEW_DATA_TOP)+"]");
			break;
		}

	}else if(memData[ARow-1].adr >= 0 && ARow < RamView->RowCount-1){
		if(memData[ARow-1].area == MEM_DATA_AREA_ROM){
			RamView->Canvas->Font->Color = clGreen;
		//}else if(memData[ARow-1].area == MEM_DATA_AREA_RAM){
			//RamView->Canvas->Font->Style = TFontStyles() << fsBold;
		}else if(memData[ARow-1].area == MEM_DATA_AREA_IO){
			RamView->Canvas->Font->Color = clBlue;
		}else if(memData[ARow-1].area == MEM_DATA_AREA_ETC){
			RamView->Canvas->Font->Color = clRed;
		}
		if(ACol == 0){
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, IntToHex(memData[ARow-1].adr, memRange[0].width));
		//t@C\
		}else if(ACol == 1){
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, memData[ARow-1].fileName);

		}else if(ACol == 2){
			if(memData[ARow-1].varName.SubString(1, 1) == "_"){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, memData[ARow-1].varName.SubString(2, 100));
			}else{
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, memData[ARow-1].varName);
			}

		}else if(ACol == 3){
			if(memData[ARow-1].mark == 1){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "}");
			}else{
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "{");
			}
		}else if(ACol == 4){
			AnsiString Size;
			if(memData[ARow-1].model == 1){
				Size = "a";
			}else if(memData[ARow-1].model == 2){
				Size = "v";
			}else if(memData[ARow-1].model == 4){
				Size = "c";
			}
			//RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "s");
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, Size);

		}else if(ACol == 5){
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, IntToStr(memData[ARow-1].size));

		}else if(ACol == 6){
			RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, memData[ARow-1].section);

		}else if(Check2->Checked == true && memData[ARow-1].model == 1){
			Adr = memData[ARow-1].adr+(ACol-RAM_VIEW_DATA_TOP)*memData[ARow-1].model;
			Adr = Adr & 0xffffff;
			if(ACol-RAM_VIEW_DATA_TOP >= memData[ARow-1].size){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "");

			}else if(memData[ARow-1].model == 1){
				char tmp[14];
				tmp[13] = 0;
				tmp[0] = ' ';
				tmp[1] = ' ';
				tmp[2] = ' ';
				tmp[3] = ' ';
				tmp[8] = ' ';
				for(int n=0;n < 4;n++){
					tmp[12-n] = ((memBuf[Adr] >> n) & 0x01) + '0';
				}
				for(int n=4;n < 8;n++){
					tmp[11-n] = ((memBuf[Adr] >> n) & 0x01) + '0';
				}

				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, tmp);
			}

		}else if(Check10->Checked == true){
			Adr = memData[ARow-1].adr+(ACol-RAM_VIEW_DATA_TOP)*memData[ARow-1].model;
			Data = GetData(Adr, memData[ARow-1].model, memData[ARow-1].mark);
			if(ACol-RAM_VIEW_DATA_TOP >= memData[ARow-1].size){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "");

			}else{
				Str = IntToStr(Data);
				if(Str.SubString(1, 1) != "-"){
					if(Str.Length() > 9){
						Str.Insert(",", Str.Length()-2);
						Str.Insert(",", Str.Length()-6);
						Str.Insert(",", Str.Length()-10);
					}else if(Str.Length() > 6){
						Str.Insert(",", Str.Length()-2);
						Str.Insert(",", Str.Length()-6);
					}else if(Str.Length() > 3){
						Str.Insert(",", Str.Length()-2);
					}

				}else{
					if(Str.Length() > 10){
						Str.Insert(",", Str.Length()-2);
						Str.Insert(",", Str.Length()-6);
						Str.Insert(",", Str.Length()-10);
					}else if(Str.Length() > 7){
						Str.Insert(",", Str.Length()-2);
						Str.Insert(",", Str.Length()-6);
					}else if(Str.Length() > 4){
						Str.Insert(",", Str.Length()-2);
					}
				}
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, AnsiString::StringOfChar(' ', 14-Str.Length())+Str);
			}

		}else{
			Adr = memData[ARow-1].adr+(ACol-RAM_VIEW_DATA_TOP)*memData[ARow-1].model;
			Adr = Adr & 0xffffff;
			if(ACol-RAM_VIEW_DATA_TOP >= memData[ARow-1].size){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "");

			}else if(memData[ARow-1].model == 1){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "           "+IntToHex(memBuf[Adr], 2));

			}else if(memData[ARow-1].model == 2){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "        "+IntToHex(memBuf[Adr], 2)+" "+IntToHex(memBuf[Adr+1], 2));

			}else if(memData[ARow-1].model == 4){
				RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "  "+IntToHex(memBuf[Adr], 2)+" "+IntToHex(memBuf[Adr+1], 2)+" "+IntToHex(memBuf[Adr+2], 2)+" "+IntToHex(memBuf[Adr+3], 2));

			}
		}
	}else{
		RamView->Canvas->TextRect(Rect, Rect.Left+4, Rect.Top+2, "");
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::RamViewMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	TGridCoord Cel;
	Cel = RamView->MouseCoord(X, Y);
	if(Shift.Contains(ssLeft) == true){
		if(Cel.X == 0 && Cel.Y == 0){
			if(sortMode[0] == SORT_MODE_ADDRESS_UP){
				sortMode[0] = SORT_MODE_ADDRESS_DOWN;
			}else{
				sortMode[0] = SORT_MODE_ADDRESS_UP;
			}
			SortData(sortMode);
			RamView->Repaint();

		}else if(Cel.X == 1 && Cel.Y == 0){
			if(sortMode[1] == SORT_MODE_FILE_NAME_NON){
				sortMode[1] = SORT_MODE_FILE_NAME_UP;
			}else if(sortMode[1] == SORT_MODE_FILE_NAME_UP){
				sortMode[1] = SORT_MODE_FILE_NAME_DOWN;
			}else{
				sortMode[1] = SORT_MODE_FILE_NAME_NON;
			}
			SortData(sortMode);
			RamView->Repaint();

		}else if(Cel.X == 2 && Cel.Y == 0){
			if(sortMode[0] == SORT_MODE_VAR_NAME_UP){
				sortMode[0] = SORT_MODE_VAR_NAME_DOWN;
			}else{
				sortMode[0] = SORT_MODE_VAR_NAME_UP;
			}
			SortData(sortMode);
			RamView->Repaint();
		}

	}else if(Shift.Contains(ssRight) == true){
		if(Cel.X == 0 && Cel.Y > 0){	//OtݒH
			popupPos = Cel.Y;
			PopupMenu3->Popup(Left+X+VarPanel->Left+40, Top+Y+70);

		}else if(Cel.X == 3){ //Cel.Y == 0̏ꍇS̕ύX
			popupPosMark = Cel.Y;
			PopupMenu2->Popup(Left+X+VarPanel->Left+40, Top+Y+70);

		}else if(Cel.X == 4 && Cel.Y > 0){
			popupPos = Cel.Y;
			PopupMenu1->Popup(Left+X+VarPanel->Left+40, Top+Y+70);

		}else if(Cel.X >= RAM_VIEW_DATA_TOP && Cel.Y > 0){
			WriteForm->Visible = false;
			WriteForm->adrWidth = memRange[0].width;
			WriteForm->adr = memData[Cel.Y-1].adr+(Cel.X-RAM_VIEW_DATA_TOP)*memData[Cel.Y-1].model;
			WriteForm->memData = GetData(WriteForm->adr, memData[Cel.Y-1].model, memData[Cel.Y-1].mark);
			WriteForm->model = memData[Cel.Y-1].model;
			WriteForm->mark = memData[Cel.Y-1].mark;
			WriteForm->Left = Left+VarPanel->Left+X+120;
			if(WriteForm->Left > Width-240){
				WriteForm->Left = Left+VarPanel->Left+X-280;
			}
			WriteForm->Top  = Top+RamView->Top+Y+20;
			if(WriteForm->Top > Height-230){
				WriteForm->Top  = Top+RamView->Top+Y-140;
			}
			SetWindowPos(WriteForm->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
 			WriteForm->Visible = true;
//			WriteForm->Show();

		}
	}
}

//---------------------------------------------------------------------------


void __fastcall TMainForm::RamViewSelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
	UINT adr;
	__int64 data;


	adr = memData[ARow-1].adr+(ACol-RAM_VIEW_DATA_TOP)*memData[ARow-1].model;
	data = GetData(adr, memData[ARow-1].model, memData[ARow-1].mark);

	RamView->Hint = IntToHex((int)adr, 4)+"F"+IntToStr(data);//+"F"+IntToHex(data, 8);
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::SectionViewChkClick(TObject *Sender)
{
	if(SectionViewChk->Checked == true){
		RamView->ColWidths[6] = 55;
	}else{
		RamView->ColWidths[6] = 0;
	}
}

//---------------------------------------------------------------------------



void __fastcall TMainForm::FileVarViewChkClick(TObject *Sender)
{
	if(FileVarViewChk->Checked == true){
		RamView->ColWidths[1] = 95;
	}else{
		RamView->ColWidths[1] = 0;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::Button2Click(TObject *Sender)
{
	oscModePos= 0;

}

//---------------------------------------------------------------------------

void __fastcall TMainForm::RamReadChkClick(TObject *Sender)
{
	SetReadAreaPermit();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::MenuItem3Click(TObject *Sender)
{
	GraphForm->SetGraphData(&memData[popupPos-1], ((TMenuItem *)Sender)->Tag);
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormShow(TObject *Sender)
{
	AnsiString fileName="";

	if(ParamCount() == 1){
		fileName = ParamStr(1);
	}


	TIniFile *iniFile;

	iniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"def\\"+"MpuGroup.def");
	iniFile->ReadSections(MpuGroupBox->Items);

	delete iniFile;

	LoadIniFile(ChangeFileExt(Application->ExeName, ".ini"), 1);
	OldSrcName1->Caption = srcFileName[0]+"(&1)";

	MemRangeGrid->ColWidths[0] = 46;
	MemRangeGrid->ColWidths[3] = 50;
	MemRangeGrid->Cells[1][0] = "TOP";
	MemRangeGrid->Cells[2][0] = "END";
	MemRangeGrid->Cells[3][0] = "SIZE";

	RangeGrid->ColWidths[0] = 46;
	RangeGrid->ColWidths[3] = 50;
	RangeGrid->Cells[1][0] = "TOP";
	RangeGrid->Cells[2][0] = "END";
	RangeGrid->Cells[3][0] = "SIZE";

	RamView->ColWidths[0] = 58;
	RamView->ColWidths[1] = 0;
	RamView->ColWidths[2] = 160;
	RamView->ColWidths[3] = 21;
	RamView->ColWidths[4] = 21;
	RamView->ColWidths[5] = 45;
	RamView->ColWidths[6] = 0;
	for(int n=0;n < 256;n++){
		RamView->ColWidths[RAM_VIEW_DATA_TOP+n] = 120;
	}

	sortMode[0]=SORT_MODE_ADDRESS_UP;
	sortMode[1]=SORT_MODE_FILE_NAME_UP;

	if(fileName != ""){
		srcFileName[0] = srcFile = srcFileName[0];
		OldSrcName1->Caption = srcFileName[0]+"(&1)";
		SrcFileRead(srcFile, "");
	}else{
		AdrFileRead(ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+"-mem.adr", ExtractFilePath(Application->ExeName)+"def\\"+MpuBox->Text+".adr");
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::TerminalCheckClick(TObject *Sender)
{
	SetWindowPos(TerminalForm->Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
	TerminalForm->Visible = ((TCheckBox *)Sender)->Checked;

}

//---------------------------------------------------------------------------

void __fastcall TMainForm::AutoMpuReadCheckClick(TObject *Sender)
{
	autoMpuRead = ((TCheckBox *)Sender)->Checked;
}

//---------------------------------------------------------------------------




