//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "Write.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWriteForm *WriteForm;
//---------------------------------------------------------------------------

__fastcall TWriteForm::TWriteForm(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::FormShow(TObject *Sender)
{
	__int64 data;
	AdrHex->Text = IntToHex(adr, adrWidth);

	AdrHex->Font->Color = clWindowText;
	DataHex->Font->Color = clWindowText;
	if(model == 1){
		memData &= 0xff;
		SizeB->Checked = true;
		DataHex->Text = IntToHex(memData, 2);

	}else if(model == 2){
		memData &= 0xffff;
		SizeW->Checked = true;
		DataHex->Text = IntToHex(memData, 4);

	}else if(model == 4){
		memData &= 0xffffffff;
		SizeD->Checked = true;
		DataHex->Text = IntToHex(memData, 8).Insert(" ", 5);

	}
	Mark->Checked = mark;
	if(mark == true){
		if(model == 1){
			data =  (char)memData;
		}else if(model == 2){
			data = (short)memData;
		}else if(model == 4){
			data = (int)memData;
		}
	}else{
		if(model == 1){
			data = (UCHAR)memData;
		}else if(model == 2){
			data = (USHORT)memData;
		}else if(model == 4){
			data = (UINT)memData;
		}
	}
	DataDec->Text = IntToStr(data);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::SizeBClick(TObject *Sender)
{
	model = 1;
	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::SizeWClick(TObject *Sender)
{
	model = 2;
	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::SizeDClick(TObject *Sender)
{
	model = 4;
	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::MarkClick(TObject *Sender)
{
	mark = Mark->Checked;
	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
	if(Button == btNext){
		memData++;

	}else{
		memData--;
	}

	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::ClearClick(TObject *Sender)
{
	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
	memData=0;
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::FormKeyPress(TObject *Sender, char &Key)
{
	if(Key == VK_RETURN){
		WriteClick(Sender);
		Key = 0;

	}else if(Key == VK_ESCAPE){
		ModalResult = mrCancel;
		Key = 0;
	}
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::AdrHexChange(TObject *Sender)
{
	__int64 data, pos;
	AnsiString str;

	str = AdrHex->Text;
	while((pos=str.Pos(" ")) > 0){
		str = str.Delete(pos, 1);
	}
	try{
		data = StrToInt64("0x"+str);
		adr= data;
		AdrHex->Font->Color = clWindowText;

	}catch ( ... ){
		AdrHex->Font->Color = clRed;
	}

}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::DataDecChange(TObject *Sender)
{
	__int64 data, pos;
	AnsiString str;

	str = DataDec->Text;
	try{
		data = StrToInt64(str);
		memData= data;
		DataDec->Font->Color = clWindowText;

	}catch ( ... ){
		DataDec->Font->Color = clRed;
	}
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::DataHexChange(TObject *Sender)
{
	__int64 data, pos;
	AnsiString str;

	str = DataHex->Text;
	while((pos=str.Pos(" ")) > 0){
		str = str.Delete(pos, 1);
	}
	try{
		data = StrToInt64("0x"+str);
		memData= data;
		DataHex->Font->Color = clWindowText;
	}catch ( ... ){
		DataHex->Font->Color = clRed;
	}
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::DataHexExit(TObject *Sender)
{
	focus=16;
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::DataDecExit(TObject *Sender)
{
	focus=10;
	FormShow(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TWriteForm::WriteClick(TObject *Sender)
{
	MainForm->MpuWriteCommand(model, adr, memData);

	if(focus == 10){
		DataDec->SetFocus();

	}else if(focus == 16){
		DataHex->SetFocus();
	}
}

//---------------------------------------------------------------------------















